require 'time'

class Time

  def yyyy ;   year.to_s    end
  def mm ;     two_d(month) end
  def dd ;     two_d(mday)  end
  def hr ;     two_d(hour)  end
  def minmin ; two_d(min)   end

  # offset == 3 means 3rd Sunday from now, -2 means two Sundays back
  #
  def sunday(offset = 1)
    raise ArgumentError.new("Argument must be nonzero") if offset == 0
    offset -=1 if offset > 0
    sunday_after(self + (offset * 7 * 24 * 60 * 60))
  end

  private 

  def two_d(num)
    sprintf("%02d", num)
  end

  # 11:59:59 on next Sunday
  #
  def sunday_after(t)
    days = (7 - t.wday) % 7
    hours = 23 - t.hour
    mins = 59 - t.min
    sex = 59 - t.sec
    s = t + (days * 24 * 60 * 60) + (hours * 60 * 60) + (mins * 60) + sex

    # Watch out for DST transition
    s -= s.gmtoff - t.gmtoff
  end
end
